package com.company.radiobuttondatagrid.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;

import java.time.OffsetDateTime;
import java.util.UUID;

@JmixEntity
@Table(name = "RB_FEEDBACK_LINE", indexes = {
        @Index(name = "IDX_RB_FEEDBACK_LINE_FEEDBACK", columnList = "FEEDBACK_ID")
})
@Entity(name = "rb_FeedbackLine")
public class FeedbackLine {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CreatedBy
    @Column(name = "CREATED_BY")
    private String createdBy;

    @CreatedDate
    @Column(name = "CREATED_DATE")
    private OffsetDateTime createdDate;

    @Column(name = "REASON")
    private String reason;

    @Column(name = "RATIONALE")
    private Integer rationale;
    @OnDeleteInverse(DeletePolicy.CASCADE)
    @JoinColumn(name = "FEEDBACK_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Feedback feedback;

    public Feedback getFeedback() {
        return feedback;
    }

    public void setFeedback(Feedback feedback) {
        this.feedback = feedback;
    }

    public Rationale getRationale() {
        return rationale == null ? null : Rationale.fromId(rationale);
    }

    public void setRationale(Rationale rationale) {
        this.rationale = rationale == null ? null : rationale.getId();
    }

    public String getReason() {
        return reason;
    }

    public void setReason(String reason) {
        this.reason = reason;
    }

    public OffsetDateTime getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(OffsetDateTime createdDate) {
        this.createdDate = createdDate;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}