package com.company.radiobuttondatagrid.view.feedback;

import com.company.radiobuttondatagrid.entity.Feedback;

import com.company.radiobuttondatagrid.entity.FeedbackLine;
import com.company.radiobuttondatagrid.entity.Rationale;
import com.company.radiobuttondatagrid.view.main.MainView;

import com.vaadin.flow.data.renderer.ComponentRenderer;
import com.vaadin.flow.data.renderer.Renderer;
import com.vaadin.flow.router.Route;
import io.jmix.flowui.UiComponents;
import io.jmix.flowui.component.radiobuttongroup.JmixRadioButtonGroup;
import io.jmix.flowui.kit.action.ActionPerformedEvent;
import io.jmix.flowui.model.CollectionContainer;
import io.jmix.flowui.model.DataContext;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

@Route(value = "feedbacks/:id", layout = MainView.class)
@ViewController("rb_Feedback.detail")
@ViewDescriptor("feedback-detail-view.xml")
@EditedEntityContainer("feedbackDc")
public class FeedbackDetailView extends StandardDetailView<Feedback> {
    @Autowired
    private UiComponents uiComponents;
    @ViewComponent
    private CollectionContainer<FeedbackLine> feedbackLineDc;
    @ViewComponent
    private DataContext dataContext;

    @Supply(to = "feedbackLineDataGrid.rationale", subject = "renderer")
    private Renderer<FeedbackLine> feedbackLineDataGridRationaleRenderer() {
        return new ComponentRenderer<>(
                customer -> {
                    // create Jmix variant of the component:
                    JmixRadioButtonGroup radioButtonGroup = uiComponents.create(JmixRadioButtonGroup.class);
                    radioButtonGroup.setReadOnly(false);
                    radioButtonGroup.setItems(Rationale.class); // your enum class
                    radioButtonGroup.setValue(customer.getRationale());
                    return radioButtonGroup;
                }
        );
    }

    @Subscribe("feedbackLineDataGrid.refresh")
    public void onFeedbackLineDataGridRefresh(final ActionPerformedEvent event) {
        FeedbackLine feedbackLine = dataContext.create(FeedbackLine.class);
        feedbackLine.setReason("Category 1");
        feedbackLine.setRationale(Rationale.EXCELLENT);
        feedbackLine.setFeedback(getEditedEntity());
        feedbackLineDc.getMutableItems().add(feedbackLine);

        FeedbackLine feedbackLine2 = dataContext.create(FeedbackLine.class);
        feedbackLine2.setReason("Category 2");
        feedbackLine2.setRationale(Rationale.VERY_GOOD);
        feedbackLine2.setFeedback(getEditedEntity());
        feedbackLineDc.getMutableItems().add(feedbackLine2);
    }
}